--- old/usr/src/uts/common/inet/ipclassifier.h	2012-08-08 12:42:18.294125385 +0000
+++ new/usr/src/uts/common/inet/ipclassifier.h	2012-08-08 12:42:18.306192053 +0000
@@ -84,7 +84,7 @@
 #define	IPCL_UDPCONN		0x00000008	/* From udp_conn_cache */
 #define	IPCL_RAWIPCONN		0x00000010	/* From rawip_conn_cache */
 #define	IPCL_RTSCONN		0x00000020	/* From rts_conn_cache */
-/* Unused			0x00000040 */
+#define	IPCL_DCCPCONN		0x00000040	/* From dccp_conn_cache */
 #define	IPCL_IPTUN		0x00000080	/* iptun module above us */
 
 #define	IPCL_NONSTR		0x00001000	/* A non-STREAMS socket */
@@ -121,6 +121,9 @@
 #define	IPCL_IS_IPTUN(connp)						\
 	((connp)->conn_flags & IPCL_IPTUN)
 
+#define	IPCL_IS_DCCP(connp)						\
+	((connp)->conn_flags & IPCL_DCCPCONN)
+
 #define	IPCL_IS_NONSTR(connp)	((connp)->conn_flags & IPCL_NONSTR)
 
 typedef struct connf_s connf_t;
@@ -237,6 +240,7 @@
 		struct rts_s	*cp_rts;	/* Pointer to rts struct */
 		struct iptun_s	*cp_iptun;	/* Pointer to iptun_t */
 		struct sctp_s	*cp_sctp;	/* For IPCL_SCTPCONN */
+		struct dccp_s	*cp_dccp;	/* Pointer to dccp struct */
 		void		*cp_priv;
 	} conn_proto_priv;
 #define	conn_tcp	conn_proto_priv.cp_tcp
@@ -245,6 +249,7 @@
 #define	conn_rts	conn_proto_priv.cp_rts
 #define	conn_iptun	conn_proto_priv.cp_iptun
 #define	conn_sctp	conn_proto_priv.cp_sctp
+#define	conn_dccp	conn_proto_priv.cp_dccp
 #define	conn_priv	conn_proto_priv.cp_priv
 
 	kcondvar_t	conn_cv;
@@ -651,6 +656,18 @@
 #define	IPCL_UDP_HASH(lport, ipst)	\
 	IPCL_PORT_HASH(lport, (ipst)->ips_ipcl_udp_fanout_size)
 
+#define	IPCL_DCCP_CONN_HASH(src, ports, ipst)				\
+	((unsigned)(ntohl((src)) ^ ((ports) >> 24) ^ ((ports) >> 16) ^	\
+	((ports) >> 8) ^ (ports)) % (ipst)->ips_ipcl_dccp_conn_fanout_size)
+
+#define	IPCL_DCCP_CONN_HASH_V6(src, ports, ipst)			\
+	IPCL_DCCP_CONN_HASH(V4_PART_OF_V6((src)), (ports), (ipst))
+
+#define	IPCL_DCCP_BIND_HASH(lport, ipst)				\
+	((unsigned)(((lport) >> 8) ^ (lport)) %				\
+	    (ipst)->ips_ipcl_dccp_bind_fanout_size)
+
+
 #define	CONN_G_HASH_SIZE	1024
 
 /* Raw socket hash function. */
